#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,c,q;
    cin>>n>>c>>q;
    string s;
    cin>>s;
    if(q==1)
    {
        int l,r;
        cin>>l>>r;
        for(int i=l-1;i<r;i++)
        {
            if(s[i]=='0')s[i]='1';
            else s[i]='0';
        }
        if(c==n)
        {
            int br=0;
            for(int i=0;i<n;i++)
            {
                if(s[i]=='1')br++;
            }
            cout<<br<<endl;
            return 0;
        }
        if(c==1)
        {
            int vre=0,br1=0;
            for(int i=0;i<n;i++)
            {
                if(s[i]=='0' && br1>0)
                {
                    vre++;
                    br1=0;
                }
                else br1++;
            }
            if(br1>0)vre++;
            cout<<vre<<endl;
            return 0;
        }
        cout<<n/2;
        return 0;
    }
    while(q--)
    {
        int l,r;
        cin>>l>>r;
        for(int i=l-1;i<r;i++)
        {
            if(s[i]=='0')s[i]='1';
            else s[i]='0';
        }
        //cout<<s;
        //continue;
        if(c==n)
        {
            int br=0;
            for(int i=0;i<n;i++)
            {
                if(s[i]=='1')br++;
            }
            cout<<br<<endl;
            continue;
        }
        if(c==1)
        {
            int vre=0,br1=0;
            for(int i=0;i<n;i++)
            {
                if(s[i]=='0' && br1>0)
                {
                    vre++;
                    br1=0;
                }
                else br1++;
            }
            if(br1>0)vre++;
            cout<<vre<<endl;
            continue;
        }
        cout<<n/2<<endl;
    }
    return 0;
}